#!/usr/bin/env python

from dynamic_reconfigure.parameter_generator_catkin import *

PKG = "video_stream_opencv_mjpg"

gen = ParameterGenerator()


class LEVEL:
    NORMAL = 0
    RUNNING = 1


#       name    type     level     description     default      min      max

gen.add("brightness", int_t, LEVEL.RUNNING, "Target brightness", 128, 1, 255)
gen.add("contrast", int_t, LEVEL.RUNNING, "Target contrast", 128, 1, 255)
gen.add("saturation", int_t, LEVEL.RUNNING, "Target saturation", 128, 1, 255)
gen.add("white_balance_auto", bool_t, LEVEL.RUNNING, "Activate or not auto white balance", True)
gen.add("gain", int_t, LEVEL.RUNNING, "Influence luminosity gain", 1, 0, 255)
gen.add("power_line_frequency", int_t, LEVEL.RUNNING, "Indicates the power line frequency of the computer : 0 = desactivate, 1 = 50Hz (FR), 2 = 60Hz (USA)", 1, 0, 2)
gen.add("white_balance_temperature", int_t, LEVEL.RUNNING, "Target white_balance_temperature", 4000, 2000, 7500)
gen.add("sharpness", int_t, LEVEL.RUNNING, "Target sharpness", 128, 0, 255)
gen.add("backlight_compensation", int_t, LEVEL.RUNNING, "Activate a backlight compensation (= influence brightness)", 0, 0, 1)
gen.add("exposure_auto", int_t, LEVEL.RUNNING, "Set the exposure mode : 1 = manual mode; 3 = Aperture Priority mode", 1, 0, 3)
gen.add("exposure_absolute", int_t, LEVEL.RUNNING, "Set up exposure", 250, 3, 2047)
gen.add("exposure_auto_priority", bool_t, LEVEL.RUNNING, "Activate or not auto exposure", True)
gen.add("pan_absolute", int_t, LEVEL.RUNNING, "Set up pan variable", 0, -36000, 36000)
gen.add("tilt_absolute", int_t, LEVEL.RUNNING, "Set up tilt variable", 0, -36000, 36000)
gen.add("focus_absolute", int_t, LEVEL.RUNNING, "Set up focus", 0, 255, 0)
gen.add("focus_auto", bool_t, LEVEL.RUNNING, "Activate auto focus", True)
gen.add("zoom_absolute", int_t, LEVEL.RUNNING, "Set up zoom", 100, 500, 100)
gen.add("led1_mode", int_t, LEVEL.RUNNING, "Modify LED mode : off = 0; on = 1; blink = 2; auto = 3", 0, 3, 0)
gen.add("led1_frequency", int_t, LEVEL.RUNNING, "Modify LED frequency (in blink mode", 0, 255, 0)


gen.add("camera_name", str_t, LEVEL.NORMAL, "Camera name", "camera")
gen.add("set_camera_fps", double_t, LEVEL.RUNNING, "Camera rate for asking new pictures", 30.0, 0.0, 1000.0)
gen.add("buffer_queue_size", int_t, LEVEL.NORMAL, "Buffer size for capturing frames", 100, 1, 1000)
gen.add("frame_id", str_t, LEVEL.RUNNING, "Camera FrameID", "camera")
gen.add("camera_info_url", str_t, LEVEL.RUNNING, "Camera info URL", "")
gen.add("flip_horizontal", bool_t, LEVEL.NORMAL, "Flip image horizontally", False)
gen.add("flip_vertical", bool_t, LEVEL.NORMAL, "Flip image vertically", False)


gen.add("loop_videofile", bool_t, LEVEL.RUNNING, "Loop videofile", False)
gen.add("reopen_on_read_failure", bool_t, LEVEL.RUNNING, "Re-open camera device on read failure", False)
gen.add("output_encoding", str_t, LEVEL.NORMAL, "Output encoding", "bgr8")
gen.add("start_frame", int_t, LEVEL.RUNNING, "Start frame of the video ", 0, 0)
gen.add("stop_frame", int_t, LEVEL.RUNNING, "Stop frame of the video", -1, -1)


exit(gen.generate(PKG, PKG, "VideoStream"))
